## elektra-0.8.1.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (Elektra)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	if (NOT FORCE_IN_SOURCE_BUILD)
		message(FATAL_ERROR
				"In-source builds are not permitted.\n"
				"Make a separate folder for building:\n"
				"    mkdir build && cd build && cmake ..\n"
				"Before that, remove the files already created:\n"
				"    rm -rf CMakeCache.txt CMakeFiles\n"
				"If you really know what you are doing\n"
				"(will overwrite original files!) use:\n"
				"    cmake -DFORCE_IN_SOURCE_BUILD=ON\n"
			)
	endif (NOT FORCE_IN_SOURCE_BUILD)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

if (ENABLE_TESTING)
	enable_testing ()
	include (Dart)
endif (ENABLE_TESTING)

#additional modules for loading libraries
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

if (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif (NOT CMAKE_BUILD_TYPE)

#needed by doxygen
set (DOMAIN libelektra.org)
set (REVERSE_DOMAIN org.libelektra)

set (KDB_VERSION_MAJOR 0)
set (KDB_VERSION_MINOR 8)
set (KDB_VERSION_MICRO 1)

set (KDB_VERSION "${KDB_VERSION_MAJOR}.${KDB_VERSION_MINOR}.${KDB_VERSION_MICRO}")
set (KDB_VERSION_MAJORMINOR "${KDB_VERSION_MAJOR}.${KDB_VERSION_MINOR}")


set (SO_VERSION 4)

include (cmake/ElektraPackaging.cmake)
include (cmake/ElektraCache.cmake)
include (cmake/ElektraCompiling.cmake)

add_subdirectory (src)
add_subdirectory (cmake)

if (BUILD_DOCUMENTATION)
	add_subdirectory (doc)
endif (BUILD_DOCUMENTATION)

if (BUILD_TESTING)
	if (BUILD_FULL OR BUILD_STATIC)
		add_subdirectory (tests)
	endif (BUILD_FULL OR BUILD_STATIC)
endif (BUILD_TESTING)

if (BUILD_FULL OR BUILD_STATIC)
	if (BUILD_EXAMPLES)
		add_subdirectory (examples)
	endif (BUILD_EXAMPLES)
endif (BUILD_FULL OR BUILD_STATIC)

if (BUILD_FULL OR BUILD_STATIC)
	add_subdirectory (benchmarks EXCLUDE_FROM_ALL)
endif (BUILD_FULL OR BUILD_STATIC)

ADD_CUSTOM_TARGET(uninstall
	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ElektraUninstall.cmake")

ADD_CUSTOM_TARGET(source-package
		COMMAND git-tag ${KDB_VERSION} && git-archive --prefix=elektra-${KDB_VERSION}/ --format=tar ${KDB_VERSION} | gzip > ${CMAKE_BINARY_DIR}/elektra-${KDB_VERSION}.tar.gz && hashsum ${CMAKE_BINARY_DIR}/elektra-${KDB_VERSION}.tar.gz > ${CMAKE_BINARY_DIR}/elektra-${KDB_VERSION}.tar.gz.hashsum
		COMMENT Make a elektra source package by using git
		VERBATIM
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		)

=== doc/CMakeLists.txt ===
find_package(Doxygen)

# do_doc
#
#name is man, html or latex
#builds and install documentation
macro (do_doc target file)
	add_custom_command (
		OUTPUT ${target}/${file}
		COMMAND ${DOXYGEN_EXECUTABLE}
		ARGS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	)

	get_filename_component (name ${target} NAME_WE)

	add_custom_target (${name} ALL
		DEPENDS ${target}/${file}
	)

	if (INSTALL_DOCUMENTATION)
		install (
			DIRECTORY ${target}
			DESTINATION ${TARGET_DOCUMENTATION_FOLDER}
		)
	endif (INSTALL_DOCUMENTATION)
endmacro (do_doc)

if (DOXYGEN_FOUND)
	set (OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

	find_package(LATEX)

	if (LATEX_COMPILER)
		set (WITH_LATEX YES)
	else (LATEX_COMPILER)
		set (WITH_LATEX NO)
	endif (LATEX_COMPILER)

	if (DOXYGEN_DOT_FOUND)
		set (WITH_DOT YES)
	else (DOXYGEN_DOT_FOUND)
		set (WITH_DOT NO)
	endif (DOXYGEN_DOT_FOUND)

	find_package(Perl)

	configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile"
		"${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
		@ONLY
	)

	do_doc(${OUTPUT_DIRECTORY}/html index.html)
	do_doc(${OUTPUT_DIRECTORY}/man man3/kdb.3)

	if (LATEX_COMPILER)
		do_doc(${OUTPUT_DIRECTORY}/latex refman.tex)

		add_custom_command (
			OUTPUT ${OUTPUT_DIRECTORY}/latex/refman.pdf
			COMMAND ${PDFLATEX_COMPILER}
			ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.tex
			WORKING_DIRECTORY ${OUTPUT_DIRECTORY}/latex/
		)

		add_custom_target (pdf ALL
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.pdf
		)
	endif (LATEX_COMPILER)
else (DOXYGEN_FOUND)
	message (STATUS "Warning, Doxygen not found, Reference Manual can't be created. But it was requested to do so.")
endif (DOXYGEN_FOUND)

=== tests/CMakeLists.txt ===
## Elektra Test Suite
#
# This file is responsible for generating all tests
# regarding elektra's core.
#
# Backends and Bindings specific tests might be in
# their folders.
#
# To run all tests, simply type:
#  make test
#
# To run specific tests, type:
#  ctest -R name
#
# To run tests with valgrind, type:
#  ctest -T memcheck
#
# To run verbose (to see output and commands), type:
#  ctest -V
#
# For example, to run keyset test with valgrind and verbose, type:
#  ctest -V -T memcheck -R ks
#
##

include (LibAddMacros)

#dont call add_headers in a loop
add_headers (HDR_FILES)

macro (do_test source)
	include_directories ("${CMAKE_CURRENT_SOURCE_DIR}")
	set (SOURCES ${HDR_FILES} ${source}.c tests.c tests.h)
	add_executable (${source} ${SOURCES})

	if (INSTALL_TESTING)
		install (TARGETS ${source} DESTINATION bin)
	endif (INSTALL_TESTING)

	if (BUILD_FULL)
		target_link_libraries (${source} elektra-full)
	else (BUILD_FULL)
		target_link_libraries (${source} elektra-static)
	endif (BUILD_FULL)

	set_target_properties (${source} PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
	set_target_properties (${source} PROPERTIES LINKER_LANGUAGE CXX)
	add_test (${source}
			"${PROJECT_BINARY_DIR}/tests/${source}"
			"${PROJECT_BINARY_DIR}/tests"
			)
endmacro (do_test)

file (GLOB TESTS test_*.c)
foreach (file ${TESTS})
	get_filename_component (name ${file} NAME_WE)
	do_test (${name})
endforeach (file ${TESTS})

if (BUILD_FULL)
	get_target_property (KDB_COMMAND kdb-full LOCATION)
else (BUILD_FULL)
	get_target_property (KDB_COMMAND kdb-static LOCATION)
endif (BUILD_FULL)


#TODO should be in kdb test folder!
configure_file(
		test_script.sh.in
		"${PROJECT_BINARY_DIR}/tests/test_script.sh"
	      )
add_test (test_script "${PROJECT_BINARY_DIR}/tests/test_script.sh" "${PROJECT_BINARY_DIR}/tests")

include_directories ("${PROJECT_SOURCE_DIR}/tests")

=== external/pkgconfig/Makefile ===
get:get.c
	gcc -o get `pkg-config --cflags --libs elektra` get.c

=== src/include/CMakeLists.txt ===
set(DISCLAMER "
/***************************************************************************
 *                                                                         *
 * This header file is AUTO GENERATED.                                     *
 * Do not edit this file, otherwise your changes will be discarded in the  *
 * next cmake run.                                                         *
 *                                                                         *
 ***************************************************************************/")

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdb.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbvar.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbvar.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbconfig.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbversion.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	)

install (FILES
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	kdbextension.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	kdbinternal.h
	kdbmodule.h
	kdbos.h
	kdbplugin.h
	kdbprivate.h
	kdbtools.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdbvar.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	DESTINATION include/${TARGET_INCLUDE_FOLDER})

=== src/plugins/CMakeLists.txt ===
foreach (plugin ${PLUGINS})
	message("-- Include Plugin ${plugin}")
	add_subdirectory ("${plugin}")
endforeach(plugin)

#symlink for default plugin?
#list (FIND BACKENDS ${BACKEND_DEFAULT} output)
#if (output GREATER -1)
#	mkdir (${CMAKE_BINARY_DIR}/dist/lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER})
#	create_symlink (
#			libelektra-${BACKEND_DEFAULT}.so
#			${CMAKE_BINARY_DIR}/dist/lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER}/libelektra-default.so
#			)
#	message ("-- Default backend: ${BACKEND_DEFAULT}")
#else (output GREATER -1)
#	message (SEND_ERROR "default backend ${BACKEND_DEFAULT} is not included")
#endif (output GREATER -1)

#install (DIRECTORY ${CMAKE_BINARY_DIR}/dist/lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER} DESTINATION lib)

=== src/plugins/dbus/CMakeLists.txt ===
find_package(DBus REQUIRED)
if (DBUS_FOUND)
	include (LibAddMacros)

	add_includes (elektra-full ${DBUS_INCLUDE_DIR})
	add_includes (elektra-full ${DBUS_ARCH_INCLUDE_DIR})
	include_directories (${DBUS_INCLUDE_DIR})
	include_directories (${DBUS_ARCH_INCLUDE_DIR})

	set (SOURCES dbus.h dbus.c sendmessage.c receivemessage.c)
	add_sources (elektra-full ${SOURCES})
	add_headers (SOURCES)

	add_library (elektra-dbus MODULE ${SOURCES})
	install (TARGETS elektra-dbus DESTINATION lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER})

	target_link_libraries (elektra-dbus ${DBUS_LIBRARIES})
	add_libraries(elektra-full ${DBUS_LIBRARIES})

	add_plugintest (dbus)
else (DBUS_FOUND)
	remove_plugin (dbus "dbus not found")
endif (DBUS_FOUND)

=== src/plugins/doc/CMakeLists.txt ===
include(LibAddMacros)

set (SOURCES doc.c)
add_sources(elektra-full ${SOURCES})
add_headers(SOURCES)

add_library(elektra-doc MODULE ${SOURCES})
install (TARGETS elektra-doc DESTINATION lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER})

=== src/plugins/glob/CMakeLists.txt ===
include (LibAddMacros)

set (SOURCES glob.h glob.c)
add_sources (elektra-full ${SOURCES})
add_headers (SOURCES)

add_library (elektra-glob MODULE ${SOURCES})
install (TARGETS elektra-glob DESTINATION lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER})

add_plugintest (glob)

=== src/plugins/iconv/CMakeLists.txt ===
include (LibAddMacros)

set (SOURCES iconv.h iconv.c)
add_sources (elektra-full ${SOURCES})
add_headers (SOURCES)

add_library (elektra-iconv MODULE ${SOURCES})
install (TARGETS elektra-iconv DESTINATION lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER})

add_plugintest (iconv)

=== src/plugins/kwallet3/CMakeLists.txt ===
include(LibAddMacros)

if (IS_DIRECTORY /usr/include/qt3 AND IS_DIRECTORY /usr/include/kde)

	set (INCLUDES /usr/include/qt3 /usr/include/kde)
	set (LIBRARIES /usr/lib${LIB_SUFFIX}/libkwalletclient.so.1 /usr/lib/libqt-mt.so.3 pthread)

	add_includes (elektra-full ${INCLUDES})
	include_directories(${INCLUDES})

	set (SOURCES kwallet.hpp kwallet.cpp)
	add_sources (elektra-full ${SOURCES})
	add_headers (SOURCES)

	add_library (elektra-kwallet MODULE ${SOURCES})
	install (TARGETS elektra-kwallet EXPORT kdbBackendFactory DESTINATION lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER})

	target_link_libraries (elektra-kwallet ${LIBRARIES})
	add_libraries(elektra-full ${LIBRARIES})

else()
	remove_plugin (kwallet3 "kde3 not found")
endif ()


#find_package( KDE4 REQUIRED )

#if (KDE4_FOUND)
# see http://techbase.kde.org/Development/Tutorials/CMake

#else (KDE4_FOUND)
#	remove_plugin(kwallet "kde not found")
#endif (KDE4_FOUND)

=== src/plugins/network/CMakeLists.txt ===
include (LibAddMacros)

set (SOURCES network.h network.c)
add_sources (elektra-full ${SOURCES})
add_headers (SOURCES)

add_library (elektra-network MODULE ${SOURCES})
install (TARGETS elektra-network DESTINATION lib${LIB_SUFFIX}/${TARGET_PLUGIN_FOLDER})

add_plugintest (network)

=== debian/changelog ===
elektra (0.8.1-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Sat, 09 Jun 2012 14:13:41 +0200

elektra (0.8.0-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Fri, 04 May 2012 14:31:28 +0200

elektra (0.8.0rc5-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Fri, 04 May 2012 09:36:29 +0200

elektra (0.8.0rc4-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Thu, 03 May 2012 10:00:46 +0200

elektra (0.8.0rc3-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Tue, 01 May 2012 23:15:48 +0200

elektra (0.8.0rc1-1) unstable; urgency=low

  * Elektra 0.8.0 repackaging

 -- Markus Raab <elektra@markus-raab.org>  Thu, 05 Apr 2012 19:01:05 +0200

elektra (0.8.0rc0-1) unstable; urgency=low

  * Elektra 0.8.0 packaging with cmake

 -- Markus Raab <elektra@markus-raab.org>  Wed, 22 Feb 2012 16:42:02 +0100

elektra (0.7.0a1-1) unstable; urgency=low

  * New upstream version.
  * Repackaged using CDBS.
  * Removed menu file, as it makes little sense for kdb(1).

 -- Andreas Rottmann <rotty@debian.org>  Thu, 22 Mar 2007 13:32:59 +0100

elektra (0.5) unstable; urgency=low

  * Split to bin and dev packages.

 -- Pier Luigi Fiorini <pierluigi.fiorini@mockup.org>  Mon, 25 Apr 2005 19:44:10 +0200

elektra (0.4.11-5) unstable; urgency=low

  * Update to 0.4.11-5

 -- Markus Raab <debian@markus-raab.rog>  Fri, 25 Mar 2005 09:35:14 +0100
 

elektra (0.4.7-2) unstable; urgency=low

  * Sarge Integrate and Update to 0.4.7

 -- Markus Raab <markus@superbyte.at>  Thu, 05 Dec 2004 12:55:10 +0200

elektra (0.4.4-2) unstable; urgency=low

  * Updated to current Version

 -- Markus Raab <markus@superbyte.at>  Thu, 23 Sep 2004 12:55:10 +0200

elektra (0.4.4-1) unstable; urgency=low

  * Some Updates

 -- Markus Raab <markus@superbyte.at>  Thu, 23 Sep 2004 12:55:10 +0200

elektra (0.4.2-1) unstable; urgency=low

  * Initial Release.

 -- Markus Raab <markus@superbyte.at>  Thu, 23 Sep 2004 12:55:10 +0200

=== debian/control ===
Source: elektra
Priority: required
Maintainer: Simon Law <sfllaw@debian.org>
Uploaders: Pier Luigi Fiorini <pierluigi.fiorini@mockup.org>
Build-Depends: debhelper (>= 4.1.0), libxml2-dev, doxygen, libboost-dev, cmake
Standards-Version: 3.7.2
Section: base

Package: libelektra-dev
Section: libdevel
Architecture: any
Depends: libelektra (>= ${Source-Version}), libc6-dev
Description: a framework to get and set configuration
 Elektra provides a universal and secure framework to store
 configuration parameters in a global, hierarchical key database. The
 core is a small library implemented in C. The plugin-based framework
 fulfills many configuration-related tasks to avoid any unnecessary code
 duplication across applications while it still allows the core to stay
 without any external dependency. Elektra abstracts from
 cross-platform-related issues with an consistent API, and allows
 applications to be aware of other applications' configurations,
 leveraging easy application integration.
 .
 This package contains the files needed to compile and link
 programs which use Elektra.
 It also contains the static library.

Package: libelektra
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: a framework to get and set configuration
 Elektra provides a universal and secure framework to store
 configuration parameters in a global, hierarchical key database. The
 core is a small library implemented in C. The plugin-based framework
 fulfills many configuration-related tasks to avoid any unnecessary code
 duplication across applications while it still allows the core to stay
 without any external dependency. Elektra abstracts from
 cross-platform-related issues with an consistent API, and allows
 applications to be aware of other applications' configurations,
 leveraging easy application integration.
 .
 This package contains the core with the set of plugins
 only having dependencies to essential packages.

Package: libelektra-xmltool
Section: libs
Architecture: any
Depends: libelektra (>= ${Source-Version}), ${shlibs:Depends}
Description: a framework to get and set configuration
 Elektra provides a universal and secure framework to store
 configuration parameters in a global, hierarchical key database. The
 core is a small library implemented in C. The plugin-based framework
 fulfills many configuration-related tasks to avoid any unnecessary code
 duplication across applications while it still allows the core to stay
 without any external dependency. Elektra abstracts from
 cross-platform-related issues with an consistent API, and allows
 applications to be aware of other applications' configurations,
 leveraging easy application integration.
 .
 This package contains plugins not included directly
 in libelektra2: xmltool.

Package: libelektra-full
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: a framework to get and set configuration
 Elektra provides a universal and secure framework to store
 configuration parameters in a global, hierarchical key database. The
 core is a small library implemented in C. The plugin-based framework
 fulfills many configuration-related tasks to avoid any unnecessary code
 duplication across applications while it still allows the core to stay
 without any external dependency. Elektra abstracts from
 cross-platform-related issues with an consistent API, and allows
 applications to be aware of other applications' configurations,
 leveraging easy application integration.
 .
 This package contains a library with all plugins linked together.

Package: libelektra-bin
Section: admin
Architecture: any
Depends: libelektra (>= ${Source-Version}), ${shlibs:Depends}
Description:a framework to get and set configuration
 Elektra provides a universal and secure framework to store
 configuration parameters in a global, hierarchical key database. The
 core is a small library implemented in C. The plugin-based framework
 fulfills many configuration-related tasks to avoid any unnecessary code
 duplication across applications while it still allows the core to stay
 without any external dependency. Elektra abstracts from
 cross-platform-related issues with an consistent API, and allows
 applications to be aware of other applications' configurations,
 leveraging easy application integration.
 .
 This package contains the Elektra kdb program.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

ELEKTRA_PLUGINS="dump;resolver;hidden;iconv;syslog;error;ccode;hosts;tracer;fstab;network;null;path;simpleini;ni;success;tcl;timeofday;type;xmltool"
#ELEKTRA_PLUGINS="dump;resolver;hidden;iconv;syslog;error;validation;xmltool;tracer;timeofday;dbus;glob;hosts;network;type;struct;path;fstab;ccode;simplei;ni;tcl;hexcode;null;ni"

# Make sure libelektra2 is built before packages depending on it
binary/libelektra-bin binary/libelektra-dev:: binary/libelektra2

install/libelektra-bin::
	install -m 644 debian/kdb.1 debian/tmp/usr/share/man/man1

CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DPLUGINS=$(ELEKTRA_PLUGINS) \
	-DKDB_DB_SYSTEM:PATH="/etc/kdb" \
	-DKDB_DB_HOME:PATH="/home" \
	-DKDB_DB_USER:PATH=".kdb"

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test:

override_dh_installdocs:
